#!/usr/bin/perl

use strict;
use warnings;

# Copyright 2011 Bart Busschots T/A Bartificer Web Solutions. All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification, are
# permitted provided that the following conditions are met:
#
#   1. Redistributions of source code must retain the above copyright notice, this list of
#      conditions and the following disclaimer.
#
#   2. Redistributions in binary form must reproduce the above copyright notice, this list
#      of conditions and the following disclaimer in the documentation and/or other materials
#      provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY BART BUSSCHOTS T/A BARTIFICER WEB SOLUTIONS ''AS IS'' AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
# BART BUSSCHOTS T/A BARTIFICER WEB SOLUTIONS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# This script runs the terminal commands recommended by F-Secure at 
# http://www.f-secure.com/v-descs/trojan-downloader_osx_flashback_i.shtml
# and reports the results.

my $output1 = `/usr/bin/defaults read /Applications/Safari.app/Contents/Info LSEnvironment 2>&1`;
my $output2 = `/usr/bin/defaults read ~/.MacOSX/environment DYLD_INSERT_LIBRARIES 2>&1`;

my $result = q{};
if($output1 =~ m/does[ ]not[ ]exist$/sx && $output2 =~ m/does[ ]not[ ]exist$/sx){
	$result = 'Both of the Terminal commands recommended by F-Secure returned the expected answer for a system that is NOT infected with Trojan-Downloader:OSX/Flashback.I';
}else{
	$result = 'One or both of the Terminal commands recommended by F-Secure for the detection of Trojan-Downloader:OSX/Flashback.I has returned a value indicating that you ARE infected. For more see the instructions at http://www.f-secure.com/v-descs/trojan-downloader_osx_flashback_i.shtml';
}

system(qq{/usr/bin/osascript -e 'tell app "System Events" to display dialog "$result"'});